import java.net.*;
import java.io.*;

public class TCPServer {
	
	public ServerSocket listenSocket = null;
    public InetSocketAddress address = null;

    public TCPServer(InetSocketAddress address)
    {
    	    this.address = address;
    }
        
    public void start()
    {
        try 
        {	
        	this.listenSocket = new ServerSocket();
        	this.listenSocket.bind(address);
        	
        	System.out.println("TCP Server started!");
        	
        	while(true)
        	{
        			Socket serviceSocket = listenSocket.accept();
        			Thread newServiceThread = new Thread(new Service(serviceSocket));
        			newServiceThread.start();
        	} 
        }
        	
        catch (Exception e) 
        {	
			e.printStackTrace();
		}
        	
    }
        
	private class Service implements Runnable
	{
		Socket serviceSocket = null;
	    ObjectInputStream in = null;
		ObjectOutputStream out = null;
		
		private Service(Socket serviceSocket)
		{					
			try
			{		
				this.serviceSocket = serviceSocket;
				this.in = new ObjectInputStream(this.serviceSocket.getInputStream());
				this.out = new ObjectOutputStream(this.serviceSocket.getOutputStream());
				this.out.flush();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		public void run()
		{
			try
			{
				while(true)
				{
					/* Receive message from the client */
					String message = (String)in.readObject();
					System.out.println("Server Received:" + message);
				
					/* Echo the message back to the client */
					out.writeObject(message);
				}
			}
			
			catch(Exception e)
			{
				e.printStackTrace();
			}
			
			finally
			{
				if(serviceSocket != null)
					
				try
				{
					serviceSocket.close();
				}
				
				catch(Exception e)
				{
						e.printStackTrace();
				}	
			}
			
		}
	}
	
	 public static void main(String args[]) 
	 {
		    int port = 3000;
		    InetSocketAddress serverAddress = new InetSocketAddress(port);
		    
		    TCPServer server = new TCPServer(serverAddress);
		    server.start();
	 }
}	
		
